## jool-9dfaf22e49f7905d94af9b73f9bee22c26d7dd4a.tar.xz

=== mod/stateful/Makefile ===
MODULES_DIR ?= /lib/modules/$(shell uname -r)
KERNEL_DIR ?= ${MODULES_DIR}/build

all:
	make -C ${KERNEL_DIR} M=$$PWD JOOL_FLAGS="${JOOL_FLAGS}"
modules:
	make -C ${KERNEL_DIR} M=$$PWD $@
modules_install:
	make -C ${KERNEL_DIR} M=$$PWD $@
install: modules_install
	depmod
clean:
	make -C ${KERNEL_DIR} M=$$PWD $@
	rm -f ../common/*.o
	rm -f ../common/nl/*.o
	rm -f ../common/rfc6145/*.o
debug:
	make all JOOL_FLAGS+=-DDEBUG

=== test/unit/Makefile ===
# Layer 1 tests (utils)
PROJECTS += addr
PROJECTS += hashtable
PROJECTS += iterator
PROJECTS += logtime
PROJECTS += pkt
PROJECTS += rbtree
PROJECTS += rfc6052
PROJECTS += rfc6056

# Layer 2 tests (tables)
PROJECTS += eamt
PROJECTS += bibtable
PROJECTS += sessiontable

# Layer 3 tests (dbs)
PROJECTS += fragdb
PROJECTS += pool4db
PROJECTS += bibdb
PROJECTS += sessiondb

# Layer 4 tests
PROJECTS += joolns

# Layer 5 tests (translation steps)
PROJECTS += filtering
PROJECTS += translate

# Layer 6 test (global translation)
PROJECTS += page


CLEANPROJECTS = $(patsubst %,%.clean,$(PROJECTS))


all: $(PROJECTS)

$(PROJECTS):
	$(MAKE) -C $@

clean: $(CLEANPROJECTS)
	find ../../mod -type f -name "*.o" -delete

$(CLEANPROJECTS):
	$(MAKE) -C $(@:.clean=) clean

.PHONY: clean $(PROJECTS) $(CLEANPROJECTS)

=== test/unit/filtering/Makefile ===
# It appears the -C's during the makes below prevent this include from happening
# when it's supposed to.
# For that reason, I can't just do "include ../common.mk". I need the absolute
# path of the file.
# Unfortunately, while the (as always utterly useless) working directory is (as
# always) brain-dead easy to access, the easiest way I found to get to the
# "current" directory is the mouthful below.
# And yet, it still has at least one major problem: if the path contains
# whitespace, `lastword $(MAKEFILE_LIST)` goes apeshit.
# This is the one and only reason why the unit tests need to be run in a
# space-free directory.
include $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))/../common.mk


FILTERING = filtering

obj-m += $(FILTERING).o

$(FILTERING)-objs += $(MIN_REQS)
$(FILTERING)-objs += ../../../mod/common/config.o
$(FILTERING)-objs += ../../../mod/common/packet.o
$(FILTERING)-objs += ../../../mod/common/pool6.o
$(FILTERING)-objs += ../../../mod/common/rbtree.o
$(FILTERING)-objs += ../../../mod/common/rfc6052.o
$(FILTERING)-objs += ../../../mod/common/xlator.o
$(FILTERING)-objs += ../../../mod/stateful/impersonator.o
$(FILTERING)-objs += ../../../mod/stateful/pool4/db.o
$(FILTERING)-objs += ../../../mod/stateful/pool4/empty.o
$(FILTERING)-objs += ../../../mod/stateful/pool4/rfc6056.o
$(FILTERING)-objs += ../../../mod/stateful/bib/db.o
$(FILTERING)-objs += ../../../mod/stateful/bib/entry.o
$(FILTERING)-objs += ../../../mod/stateful/bib/pkt_queue.o
$(FILTERING)-objs += ../framework/skb_generator.o
$(FILTERING)-objs += ../framework/types.o
$(FILTERING)-objs += ../impersonator/icmp_wrapper.o
$(FILTERING)-objs += ../impersonator/nf_hook.o
$(FILTERING)-objs += ../impersonator/route.o
$(FILTERING)-objs += impersonator.o
$(FILTERING)-objs += filtering_and_updating_test.o

$(FILTERING)-objs += ../../../mod/common/ipv6_hdr_iterator.o
$(FILTERING)-objs += ../../../mod/common/rfc6145/common.o
$(FILTERING)-objs += ../../../mod/common/rfc6145/4to6.o
$(FILTERING)-objs += ../../../mod/common/rfc6145/6to4.o

all:
	make -C ${KERNEL_DIR} M=$$PWD;
modules:
	make -C ${KERNEL_DIR} M=$$PWD $@;
clean:
	make -C ${KERNEL_DIR} M=$$PWD $@;
	rm -f  *.ko  *.o
test:
	sudo dmesg -C
	-sudo insmod $(FILTERING).ko && sudo rmmod $(FILTERING)
	sudo dmesg -tc | less

=== test/unit/joolns/Makefile ===
# It appears the -C's during the makes below prevent this include from happening
# when it's supposed to.
# For that reason, I can't just do "include ../common.mk". I need the absolute
# path of the file.
# Unfortunately, while the (as always utterly useless) working directory is (as
# always) brain-dead easy to access, the easiest way I found to get to the
# "current" directory is the mouthful below.
# And yet, it still has at least one major problem: if the path contains
# whitespace, `lastword $(MAKEFILE_LIST)` goes apeshit.
# This is the one and only reason why the unit tests need to be run in a
# space-free directory.
include $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))/../common.mk


EXTRA_CFLAGS += -DSIIT

JOOLNS = joolns

obj-m += $(JOOLNS).o

$(JOOLNS)-objs += $(MIN_REQS)
$(JOOLNS)-objs += ../../../mod/common/atomic_config.o
$(JOOLNS)-objs += ../../../mod/common/config.o
$(JOOLNS)-objs += ../../../mod/common/rtrie.o
$(JOOLNS)-objs += ../../../mod/common/xlator.o
$(JOOLNS)-objs += ../../../mod/stateless/blacklist4.o
$(JOOLNS)-objs += ../../../mod/stateless/pool.o
$(JOOLNS)-objs += ../../../mod/stateless/rfc6791.o
$(JOOLNS)-objs += ../../../mod/stateless/eam.o
$(JOOLNS)-objs += ../../../mod/stateless/impersonator.o
$(JOOLNS)-objs += ../impersonator/nf_hook.o
$(JOOLNS)-objs += ../impersonator/route.o
$(JOOLNS)-objs += impersonator.o
$(JOOLNS)-objs += joolns_test.o


all:
	make -C ${KERNEL_DIR} M=$$PWD;
modules:
	make -C ${KERNEL_DIR} M=$$PWD $@;
clean:
	make -C ${KERNEL_DIR} M=$$PWD $@;
	rm -f  *.ko  *.o
test:
	sudo dmesg -C
	-sudo insmod $(JOOLNS).ko && sudo rmmod $(JOOLNS)
	sudo dmesg -tc | less

=== test/unit/page/Makefile ===
# It appears the -C's during the makes below prevent this include from happening
# when it's supposed to.
# For that reason, I can't just do "include ../common.mk". I need the absolute
# path of the file.
# Unfortunately, while the (as always utterly useless) working directory is (as
# always) brain-dead easy to access, the easiest way I found to get to the
# "current" directory is the mouthful below.
# And yet, it still has at least one major problem: if the path contains
# whitespace, `lastword $(MAKEFILE_LIST)` goes apeshit.
# This is the one and only reason why the unit tests need to be run in a
# space-free directory.
include $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))/../common.mk


EXTRA_CFLAGS += -DSIIT

PAGE = page

obj-m += $(PAGE).o

$(PAGE)-objs += $(MIN_REQS)
$(PAGE)-objs += ../impersonator/icmp_wrapper.o
$(PAGE)-objs += ../impersonator/nf_hook.o
$(PAGE)-objs += ../impersonator/route.o
$(PAGE)-objs += ../framework/skb_generator.o
$(PAGE)-objs += ../framework/types.o

$(PAGE)-objs += ../../../mod/common/config.o
$(PAGE)-objs += ../../../mod/common/ipv6_hdr_iterator.o
$(PAGE)-objs += ../../../mod/common/packet.o
$(PAGE)-objs += ../../../mod/common/pool6.o
$(PAGE)-objs += ../../../mod/common/rfc6052.o
$(PAGE)-objs += ../../../mod/common/rtrie.o
$(PAGE)-objs += ../../../mod/common/translation_state.o
$(PAGE)-objs += ../../../mod/common/xlator.o
$(PAGE)-objs += ../../../mod/stateless/blacklist4.o
$(PAGE)-objs += ../../../mod/stateless/eam.o
$(PAGE)-objs += ../../../mod/stateless/impersonator.o
$(PAGE)-objs += ../../../mod/stateless/pool.o
$(PAGE)-objs += ../../../mod/stateless/rfc6791.o
$(PAGE)-objs += ../../../mod/stateless/rfc6791v6.o

$(PAGE)-objs += ../../../mod/stateless/handling_hairpinning.o
$(PAGE)-objs += ../../../mod/common/rfc6145/4to6.o
$(PAGE)-objs += ../../../mod/common/rfc6145/6to4.o
$(PAGE)-objs += ../../../mod/common/rfc6145/common.o
$(PAGE)-objs += ../../../mod/common/rfc6145/core.o
$(PAGE)-objs += ../../../mod/common/core.o

$(PAGE)-objs += impersonator.o
$(PAGE)-objs += page_test.o


all:
	make -C ${KERNEL_DIR} M=$$PWD;
modules:
	make -C ${KERNEL_DIR} M=$$PWD $@;
clean:
	make -C ${KERNEL_DIR} M=$$PWD $@;
	rm -f  *.ko  *.o
test:
	sudo dmesg -C
	-sudo insmod $(PAGE).ko && sudo rmmod $(PAGE)
	sudo dmesg -tc | less

=== test/unit/pool4-iterations/Makefile ===
# It appears the -C's during the makes below prevent this include from happening
# when it's supposed to.
# For that reason, I can't just do "include ../common.mk". I need the absolute
# path of the file.
# Unfortunately, while the (as always utterly useless) working directory is (as
# always) brain-dead easy to access, the easiest way I found to get to the
# "current" directory is the mouthful below.
# And yet, it still has at least one major problem: if the path contains
# whitespace, `lastword $(MAKEFILE_LIST)` goes apeshit.
# This is the one and only reason why the unit tests need to be run in a
# space-free directory.
include $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))/../common.mk


ITERATIONS = pool4-iterations

obj-m += $(ITERATIONS).o

$(ITERATIONS)-objs += $(MIN_REQS)
$(ITERATIONS)-objs += ../../../mod/common/rbtree.o
$(ITERATIONS)-objs += ../../../mod/stateful/pool4/empty.o
$(ITERATIONS)-objs += ../../../mod/stateful/pool4/rfc6056.o
$(ITERATIONS)-objs += ../impersonator/route.o
$(ITERATIONS)-objs += iterations.o


all:
	make -C ${KERNEL_DIR} M=$$PWD;
modules:
	make -C ${KERNEL_DIR} M=$$PWD $@;
clean:
	make -C ${KERNEL_DIR} M=$$PWD $@;
	rm -f  *.ko  *.o

=== test/unit/pool4db/Makefile ===
# It appears the -C's during the makes below prevent this include from happening
# when it's supposed to.
# For that reason, I can't just do "include ../common.mk". I need the absolute
# path of the file.
# Unfortunately, while the (as always utterly useless) working directory is (as
# always) brain-dead easy to access, the easiest way I found to get to the
# "current" directory is the mouthful below.
# And yet, it still has at least one major problem: if the path contains
# whitespace, `lastword $(MAKEFILE_LIST)` goes apeshit.
# This is the one and only reason why the unit tests need to be run in a
# space-free directory.
include $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))/../common.mk


POOL4DB = pool4db

obj-m += $(POOL4DB).o

$(POOL4DB)-objs += $(MIN_REQS)
$(POOL4DB)-objs += ../../../mod/common/rbtree.o
$(POOL4DB)-objs += ../../../mod/stateful/pool4/empty.o
$(POOL4DB)-objs += ../impersonator/route.o
$(POOL4DB)-objs += impersonator.o
$(POOL4DB)-objs += pool4db_test.o


all:
	make -C ${KERNEL_DIR} M=$$PWD;
modules:
	make -C ${KERNEL_DIR} M=$$PWD $@;
clean:
	make -C ${KERNEL_DIR} M=$$PWD $@;
	rm -f  *.ko  *.o
test:
	sudo dmesg -C
	-sudo insmod $(POOL4DB).ko && sudo rmmod $(POOL4DB)
	sudo dmesg -tc | less

=== test/unit/rfc6056/Makefile ===
# It appears the -C's during the makes below prevent this include from happening
# when it's supposed to.
# For that reason, I can't just do "include ../common.mk". I need the absolute
# path of the file.
# Unfortunately, while the (as always utterly useless) working directory is (as
# always) brain-dead easy to access, the easiest way I found to get to the
# "current" directory is the mouthful below.
# And yet, it still has at least one major problem: if the path contains
# whitespace, `lastword $(MAKEFILE_LIST)` goes apeshit.
# This is the one and only reason why the unit tests need to be run in a
# space-free directory.
include $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))/../common.mk


PALLOC = rfc6056

obj-m += $(PALLOC).o

$(PALLOC)-objs += $(MIN_REQS)
$(PALLOC)-objs += ../framework/types.o
$(PALLOC)-objs += rfc6056_test.o


all:
	make -C ${KERNEL_DIR} M=$$PWD;
modules:
	make -C ${KERNEL_DIR} M=$$PWD $@;
clean:
	make -C ${KERNEL_DIR} M=$$PWD $@;
	rm -f  *.ko  *.o
test:
	sudo dmesg -C
	-sudo insmod $(PALLOC).ko && sudo rmmod $(PALLOC)
	sudo dmesg -tc | less

=== test/unit/sessiontable/Makefile ===
# It appears the -C's during the makes below prevent this include from happening
# when it's supposed to.
# For that reason, I can't just do "include ../common.mk". I need the absolute
# path of the file.
# Unfortunately, while the (as always utterly useless) working directory is (as
# always) brain-dead easy to access, the easiest way I found to get to the
# "current" directory is the mouthful below.
# And yet, it still has at least one major problem: if the path contains
# whitespace, `lastword $(MAKEFILE_LIST)` goes apeshit.
# This is the one and only reason why the unit tests need to be run in a
# space-free directory.
include $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))/../common.mk


SESSIONTABLE = sessiontable

obj-m += $(SESSIONTABLE).o

$(SESSIONTABLE)-objs += $(MIN_REQS)
$(SESSIONTABLE)-objs += ../../../mod/common/config.o
$(SESSIONTABLE)-objs += ../../../mod/common/rbtree.o
$(SESSIONTABLE)-objs += ../../../mod/stateful/bib/db.o
$(SESSIONTABLE)-objs += ../impersonator/icmp_wrapper.o
$(SESSIONTABLE)-objs += ../impersonator/bib.o
$(SESSIONTABLE)-objs += ../impersonator/route.o
$(SESSIONTABLE)-objs += sessiontable_test.o


all:
	make -C ${KERNEL_DIR} M=$$PWD;
modules:
	make -C ${KERNEL_DIR} M=$$PWD $@;
clean:
	make -C ${KERNEL_DIR} M=$$PWD $@;
	rm -f  *.ko  *.o
test:
	sudo dmesg -C
	-sudo insmod $(SESSIONTABLE).ko && sudo rmmod $(SESSIONTABLE)
	sudo dmesg -tc | less

=== test/unit/translate/Makefile ===
# It appears the -C's during the makes below prevent this include from happening
# when it's supposed to.
# For that reason, I can't just do "include ../common.mk". I need the absolute
# path of the file.
# Unfortunately, while the (as always utterly useless) working directory is (as
# always) brain-dead easy to access, the easiest way I found to get to the
# "current" directory is the mouthful below.
# And yet, it still has at least one major problem: if the path contains
# whitespace, `lastword $(MAKEFILE_LIST)` goes apeshit.
# This is the one and only reason why the unit tests need to be run in a
# space-free directory.
include $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))/../common.mk


TRANSLATE = translate

obj-m += $(TRANSLATE).o

$(TRANSLATE)-objs += $(MIN_REQS)
$(TRANSLATE)-objs += ../../../mod/common/config.o
$(TRANSLATE)-objs += ../../../mod/common/ipv6_hdr_iterator.o
$(TRANSLATE)-objs += ../../../mod/common/packet.o
$(TRANSLATE)-objs += ../../../mod/common/pool6.o
$(TRANSLATE)-objs += ../../../mod/common/rfc6052.o
$(TRANSLATE)-objs += ../../../mod/common/rfc6145/common.o
$(TRANSLATE)-objs += ../../../mod/stateful/impersonator.o
$(TRANSLATE)-objs += ../framework/skb_generator.o
$(TRANSLATE)-objs += ../framework/types.o
$(TRANSLATE)-objs += ../impersonator/icmp_wrapper.o
$(TRANSLATE)-objs += translate_packet_test.o


all:
	make -C ${KERNEL_DIR} M=$$PWD;
modules:
	make -C ${KERNEL_DIR} M=$$PWD $@;
clean:
	make -C ${KERNEL_DIR} M=$$PWD $@;
	rm -f  *.ko  *.o
test:
	sudo dmesg -C
	-sudo insmod $(TRANSLATE).ko && sudo rmmod $(TRANSLATE)
	sudo dmesg -tc | less

=== dkms-packaging/deb/jool-dkms-mkdeb/debian/control ===
Source: DEBIAN_PACKAGE-dkms
Section: net
Priority: optional
Maintainer: Oswaldo Perez <oswaldo.perez.dominguez@gmail.com>
Build-Depends: debhelper (>= 7), dkms, pkg-config, automake, linux-headers-amd64, build-essential, libnl-genl-3-dev (>= 3.1)
Standards-Version: 1.2.38
Homepage: jool.mx

Package: DEBIAN_PACKAGE-dkms
Architecture: all
Depends: dkms (>= 1.95), pkg-config, linux-headers-amd64, automake, build-essential, libnl-genl-3-dev(>= 3.1), ${misc:Depends}
Description: This package uses DKMS to automatically build the jool kernel modules.
 Jool is an Open Source implementation of IPv4/IPv6 Translation on Linux. Until version 3.2.x, it used to be only a Stateful NAT64; starting from 3.3.0, it also supports SIIT mode. Jool supports Linux kernels 3.2.0 and above. Jool is a Netfilter module that hooks itself to the prerouting chain. Because Netfilter isn’t comfortable with packets changing layer-3 protocols, Jool has its own forwarding pipeline, which only translating packets traverse. You can hook one instance of SIIT Jool and one instance of NAT64 Jool per network namespace.

=== dkms-packaging/deb/jool-dkms-mkdsc/debian/control ===
Source: DEBIAN_PACKAGE-dkms
Section: net
Priority: optional
Maintainer: Oswaldo Perez <oswaldo.perez.dominguez@gmail.com>
Build-Depends: debhelper (>= 7), dkms, pkg-config, linux-headers-amd64, automake, build-essential, libnl-genl-3-dev (>= 3.1)
Standards-Version: 1.2.38
Homepage: jool.mx

Package: DEBIAN_PACKAGE-dkms
Architecture: all
Depends: dkms (>= 1.95), pkg-config, linux-headers-amd64, automake, build-essential, libnl-genl-3-dev(>= 3.1), ${misc:Depends}
Description: This package uses DKMS to automatically build the jool kernel modules and userspace apps.
 Jool is an Open Source implementation of IPv4/IPv6 Translation (SIIT and NAT64) on Linux.
